function [Out,bDs]=set_aXpbY(N,verbose,varargin)
  % example of 'set_fun' function used in bench
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('d',[2,2],@(x) ismember(length(x),[1,2]));
  p.addParamValue('fprintf',@(varargin) fprintf(varargin{:}));
  p.addParamValue('ltype','array3d',@(s) ismember(lower(s),{'array3d','array2d','array1d','constant'}));
  p.addParamValue('rtype','array3d',@(s) ismember(lower(s),{'array3d','array2d','array1d','constant'}));
  p.parse(varargin{:});
  R=p.Results;
  %mattype=R.mattype;
  R.ltype=lower(R.ltype);R.rtype=lower(R.rtype);
  Fprintf=R.fprintf;
  d=R.d;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  assert( strcmp(R.ltype,'array3d') || strcmp(R.rtype,'array3d') )
  
  if verbose
    Fprintf('# Prototype functions: Z=fun(a,X,b,Y)\n');
    Fprintf('# Computes a*X+b*Y)\n');
  end
  if verbose, Fprintf('# 1st parameter is :\n');end
  [a,~]=fc_linalg3D.benchs.set_datas(N,verbose,'d',d,'type','constant',varargin{:});
  if verbose, Fprintf('# 2nd parameter is :\n');end
  [X,~]=fc_linalg3D.benchs.set_datas(N,verbose,'d',d,'type',R.ltype,varargin{:});
  if verbose, Fprintf('# 3th parameter is :\n');end
  [b,~]=fc_linalg3D.benchs.set_datas(N,verbose,'d',d,'type','constant',varargin{:});
  if verbose, Fprintf('# 4th parameter is :\n');end
  [Y,~]=fc_linalg3D.benchs.set_datas(N,verbose,'d',d,'type',R.rtype,varargin{:});

  bDs(1)=fc_bench.bdata('N',N,'%d',10);
  Out={a{1},X{1},b{1},Y{1}};
end
