function D=detLapIdx_Vec(A,varargin)
% A : N-by-d-by-d
% D : N-by-1
% D(i) = det A(i,:,:)
% Vectorized version using Laplace expansion
  N=size(A,1);d=size(A,2);
  if nargin==1 
    I=1:d;J=1:d;
    m=d;
  else
    I=varargin{1};J=varargin{2};
    assert(length(I)==length(J))
    m=length(I);
  end
  if m==1,  D=A(:,I(1),J(1));  return; end
  if m==2,  D=A(:,I(1),J(1)).*A(:,I(2),J(2)) - A(:,I(1),J(2)).*A(:,I(2),J(1)); return; end   
  D=zeros(N,1);  
  for j=1:m 
     D=D+(-1)^(j+1)*(A(:,I(1),J(j)).*fc_linalg3D.det.detLapIdx_Vec(A,I(2:m),J([1:j-1,j+1:m])));
  end
end
