function C=aXpbY_Cvt(a,X,b,Y)
% function C=aXpbY(a,X,b,Y)
%   returns C=a*X+b*Y
%    assert( isscalar(a) && isscalar(b) )
%    if max(size(X))==1 || max(size(Y))==1, C=a*X+b*Y;return;end % X or Y is constant (to improve performance)
%    if fc_linalg3D.is3Darray(X) && fc_linalg3D.is3Darray(Y), C=a*X+b*Y;return;end % X and Y are 3D-arrays (to improve performance)
  C=fc_linalg3D.aXpbY_init(a,X,b,Y); % 
  if ~isempty(C), return;end
  [N,dimX,dimY]=fc_linalg3D.getNdims(X,Y);
  m=max(dimX(2),dimY(2));n=max(dimX(3),dimY(3));
  X3D=fc_linalg3D.to3Darray(X,N,m,n);
  Y3D=fc_linalg3D.to3Darray(Y,N,m,n);
  C=a*X3D+b*Y3D;
end
